#define OPTIMIZE_ROM_CALLS    
#include <tigcclib.h>        
int _ti89; 
#define ARROWS_ROW 0xfffe
#define K_KEY_LEFT 2
#define K_KEY_RIGHT 8
#define K_KEY_UP 1
#define K_KEY_DOWN 4
#define ESC_ROW 0xffbf
#define ENTER_ROW 0xfffd
#define ESC_KEY 1
#define K_KEY_ENTER 1
#define K_KEY_CLR 64
void DrawPdl(int row,int col,int ca){
	int r,c;
	for(r=row+(ca*2);r<row+3;r++){
		for(c=col;c<col+20;c++){
			DrawPix(c,r,A_XOR);
		}
	}
}
void DrawPdlV(int row,int col,int ca){
	int r,c;
	for(r=row;r<row+20;r++){
		for(c=col+(ca*2);c<col+3;c++){
			DrawPix(c,r,A_XOR);
		}
	}	
}
void DrawBall(int row,int col){
	DrawPix(col+1,row,A_XOR);
	DrawPix(col+2,row,A_XOR);
	DrawPix(col+3,row,A_XOR);
	DrawPix(col,row+1,A_XOR);
	DrawPix(col+1,row+1,A_XOR);
	DrawPix(col+2,row+1,A_XOR);
	DrawPix(col+3,row+1,A_XOR);
	DrawPix(col+4,row+1,A_XOR);
	DrawPix(col,row+2,A_XOR);
	DrawPix(col+1,row+2,A_XOR);
	DrawPix(col+2,row+2,A_XOR);
	DrawPix(col+3,row+2,A_XOR);
	DrawPix(col+4,row+2,A_XOR);
	DrawPix(col+1,row+3,A_XOR);
	DrawPix(col+2,row+3,A_XOR);
	DrawPix(col+3,row+3,A_XOR);
}

void KEY_GET(int *pp,int *pa,int *rtq,int *ghj,int *pp2){
	int t;
	if((*ghj)<=11)
		(*ghj)++;
	t=_rowread(ARROWS_ROW);
	if(t&K_KEY_LEFT || t&K_KEY_RIGHT) DrawPdl(97,*pp,0);
	if(t&K_KEY_UP || t&K_KEY_DOWN) DrawPdlV(*pp2,157,0);
	if (t&K_KEY_LEFT) *pp=max(1,*pp-*pa);
	if (t&K_KEY_RIGHT) *pp=min(138,*pp+*pa);
	
	if (t&K_KEY_UP) *pp2=max(15,*pp2-*pa);
	if (t&K_KEY_DOWN) *pp2=min(76,*pp2+*pa);
	if(t&K_KEY_UP || t&K_KEY_DOWN) DrawPdlV(*pp2,157,0);

	if(t&K_KEY_LEFT || t&K_KEY_RIGHT) DrawPdl(97,*pp,0);
	if(_rowread(ESC_ROW)&ESC_KEY) *rtq=1;
	if ((_rowread(ENTER_ROW)&K_KEY_ENTER) && (*ghj)>10){
		(*ghj)=0;
		off();
	}
				
}
void Wait(int diff){
	int d,j;
	for(d=1;d<diff+1;d++){
		for(j=0;j<1001;j++);
	}
}
void DrawScore(int score){
	char scr[6];
	sprintf(scr,"%i",score);
	FontSetSys(F_8x10);
	DrawStr(56,1,"      ",A_REPLACE);
	DrawStr((160-(strlen(scr)*8))/2,1,scr,A_REVERSE);
	FontSetSys(F_6x8);
}

void _main(void)
{
	int rtq;
	int hj;
	char tmp[20];
	LCD_BUFFER lbuf;
	int score=0,pa=1,bp[]={1,1},ba[]={1,1}, pp=1,pp2=15,b[2];
	SCR_RECT s;
	hj=0;
	s.xy.x0=0;
	s.xy.y0=0;
	s.xy.x1=159;
	s.xy.y1=99;
	rtq=0;
	GKeyFlush();
	OSSetSR(0x0400);
	OSInitKeyInitDelay (1);
	OSInitBetweenKeyDelay (1);
	LCD_save(lbuf);
	ClrScr();
	FontSetSys(F_8x10);
	DrawStr(25,10," 4 Sided Pong ",A_REVERSE);
	FontSetSys(F_6x8);
	DrawStr(25,21,"By: Dmitry Grinberg" , A_NORMAL);
	DrawStr(25,30,"dmitrygr@home.com",A_NORMAL);
	FontSetSys(F_4x6);
	DrawStr(40,95,"Press any key to begin...",A_NORMAL);
	FontSetSys(F_6x8);
	DrawBall(bp[0],bp[1]);
	while(kbhit()==0){
		DrawBall(bp[0],bp[1]);
		bp[1]=bp[1]+ba[1];
		bp[0]=bp[0]+ba[0];
		if(bp[0]<0 || bp[0]>96){
			ba[0]=-ba[0];
			bp[0]=bp[0]+2*ba[0];
		}
		if(bp[1]<0 || bp[1]>155){
			ba[1]=-ba[1];
			bp[1]=bp[1]+2*ba[1];
		}
		DrawBall(bp[0],bp[1]);
		Wait(20);
	}
	ba[1]=1;
	ba[0]=1;
	bp[0]=13;
	bp[1]=0;
	GKeyFlush();
	OSSetSR(0x0400);
	OSInitKeyInitDelay (1);
	OSInitBetweenKeyDelay (1);
	ClrScr();
	FontSetSys(F_8x10);
	DrawPdlV(max(min(76,bp[0]-10),15),0,1);
	DrawPdlV(pp2,157,0);
	DrawPdl(97,min(pp,138),0);
	while (rtq==0){
		DrawScore(score);
		DrawBall(bp[0],bp[1]);
		DrawPdl(12,max(min(138,bp[1]-10),1),1);
		DrawPdlV(max(min(76,bp[0]-10),15),0,1);
		KEY_GET(&pp,&pa,&rtq,&hj,&pp2);
		b[0]=bp[0];
		b[1]=bp[1];
		bp[0]=bp[0]+ba[0];
		bp[1]=bp[1]+ba[1];
		if(bp[0]<=14){
			ba[0]=1;
			bp[0]=15;
		}
		if(bp[1]<=2){
			ba[1]=1;
			bp[1]=3;
		}
		if(bp[0]>=93 || bp[1]>=153){
			if(bp[1]>=pp-3 && bp[1]<=pp+18 && bp[0]>=93){
				score=score+1;
				ba[0]=-1;
				bp[0]=92;
			}
			else{
				if(bp[0]>=pp2-4 && bp[0]<=pp2+18 && bp[1]>=153){
					score=score+1;
					ba[1]=-1;
					bp[1]=152;
				}
				else{
					rtq=1;
				}
			}
		}
		Wait(20);
		KEY_GET(&pp,&pa,&rtq,&hj,&pp2);
		DrawBall(b[0],b[1]);
		DrawPdl(12,max(min(138,b[1]-10),1),1);
		DrawPdlV(max(min(76,bp[0]-10),15),0,1);
		KEY_GET(&pp,&pa,&rtq,&hj,&pp2);
	}
	ClrScr();
	ScrRectFill(&s,&s,A_NORMAL);
	FontSetSys(F_8x10);
	DrawStr(37,10,"Game Over!",A_REVERSE);
	sprintf(tmp,"Your score is:%d",score);
	FontSetSys(F_6x8);
	DrawStr((160-strlen(tmp)*7)/2,40,tmp,A_REVERSE);
	OSFreeTimer (USER_TIMER);
	OSRegisterTimer (USER_TIMER, 5*20);
	while (!OSTimerExpired (USER_TIMER));
	for(pp=0;pp<1000;pp++){
		DrawPix(random(159),random(99),A_XOR);
		for(pa=0;pa<500;pa++);
	}
	DrawStr((160-strlen(tmp)*7)/2,40,tmp,A_REVERSE);
	OSFreeTimer (USER_TIMER);
	OSRegisterTimer (USER_TIMER, 2*20);
	ClrScr();
	LCD_restore(lbuf);
	kbhit();
	OSInitBetweenKeyDelay(48);
	OSInitKeyInitDelay(336);
}
